#include <SPI.h>
#include <LiquidCrystal.h>

LiquidCrystal lcd(12, 11, 5, 4, 3, 2);


#define  DEV_ADDR  (0x20 + 0)  // NOTE: 7bit address

const int  dev_CS_pin  = 10;

void spi_write(int address, byte reg, byte data)
{
  digitalWrite(dev_CS_pin, LOW);

  SPI.transfer(address << 1);
  SPI.transfer(reg);
  SPI.transfer(data);

  digitalWrite(dev_CS_pin, HIGH);
}

byte spi_read(int address, byte reg)
{
  byte ret;

  digitalWrite(dev_CS_pin, LOW);

  SPI.transfer((address << 1) | 0x01);
  SPI.transfer(reg);
  ret = SPI.transfer(0x00);

  digitalWrite(dev_CS_pin, HIGH);
  return ret;
}

void setup()
{
  lcd.begin(16, 2);
  lcd.clear();
  lcd.display();

  pinMode(dev_CS_pin, OUTPUT);
  digitalWrite(dev_CS_pin, HIGH);

  SPI.begin();
  SPI.setBitOrder(MSBFIRST);

  spi_write(DEV_ADDR, 0x0A, 0xAE);  // IOCON    NOTE: address of this resister just after PON
  spi_write(DEV_ADDR, 0x00, 0x00);  // IODIRA
  spi_write(DEV_ADDR, 0x10, 0x00);  // IODIRB

  spi_write(DEV_ADDR, 0x19, 0x5A);  // GPIOB
}

void loop()
{
  byte inval, outval;
  char buf[16];

  outval  = 0;

  while (1) {
//    inval = spi_read(DEV_ADDR, 0x09);
//    lcd.setCursor(0, 0);
//    sprintf(buf, "IN: %02x", inval);
//    lcd.print(buf);

    spi_write(DEV_ADDR, 0x19, outval);  // GPIOB
    outval  = (outval + 1) & 0xFF;
  }
}

