#include <Wire.h>
#include <LiquidCrystal.h>

LiquidCrystal lcd(12, 11, 5, 4, 3, 2);


void i2c_write(int address, byte reg, byte data) {
  // Send output register address
  Wire.beginTransmission(address);
  Wire.write(reg);
  // Connect to device and send byte
  Wire.write(data); // low byte
  Wire.endTransmission(true);    // stop
}

byte i2c_read(int address, byte reg) {
 byte ret;
 // Send input register address
 Wire.beginTransmission(address);
 Wire.write(reg);
 Wire.endTransmission(false);	// restart
 Wire.requestFrom(address, 1);
 ret = Wire.read();
 Wire.endTransmission(true);  // stop
 return ret;
}

#define  DEV_ADDR  (0x12 + 0)  // NOTE: 7bit address

void setup()
{
  // set up the LCD's number of columns and rows: 
  lcd.begin(16, 2);
  lcd.clear();
  lcd.display();

  Wire.begin(); // join i2c bus (address optional for master)
}

void loop()
{
  byte led_r, led_g, led_b;
  byte  snsval0, snsval1, snsval2;
  char buf[16];

  led_r  = 0;
  led_g  = 0;
  led_b  = 0;

  while (1) {
    // change LED  
    i2c_write(DEV_ADDR, 0x01, led_r);
    i2c_write(DEV_ADDR, 0x02, led_g);
    i2c_write(DEV_ADDR, 0x03, led_b);

    led_r  = (led_r + 32) & 0xFF;
    if (led_r == 0) {
      led_g  = (led_g + 32) & 0xFF;
      if (led_g == 0) {
        led_b  = (led_b + 32) & 0xFF;
      }
    }

    // read sensor
    snsval0 = i2c_read(DEV_ADDR, 0x11);
    snsval1 = i2c_read(DEV_ADDR, 0x12);
    snsval2 = i2c_read(DEV_ADDR, 0x13);
    sprintf(buf, "SNS %02x%02x%02x", snsval2, snsval1, snsval0);
    lcd.setCursor(0, 0);
    lcd.print(buf);
  }
}
